*****************************************************************
      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*----------------- EXAMPLE FIVE -----------------------------
*
*****************************************************************
      DIMENSION T(22,22)
      EQUIVALENCE (F(1,1,4),T(1,1))
*
      ENTRY GRID
      LSOLVE(4)=.TRUE.
      TITLE(1)='.VEL  U.'
      TITLE(2)='.VEL  V.'
      TITLE(3)='.STR FN.'
      TITLE(4)='. TEMP .'
      LPRINT(1)=.TRUE.
      LPRINT(2)=.TRUE.
      LPRINT(3)=.TRUE.
      LPRINT(4)=.TRUE.
      XL=1.
      YL=1.
      L1=7
      M1=7
      CALL UGRID
      RETURN
*
      ENTRY START
      DO 100 J=1,M1
      DO 100 I=1,L1
      U(I,J)=10.*FLOAT(I-2)/FLOAT(L1-2)
      V(I,J)=-10.*FLOAT(J-2)/FLOAT(M1-2)
      T(I,J)=50.
      T(1,J)=100.
  100 CONTINUE
      RETURN
*
      ENTRY DENSE
      RETURN
*
      ENTRY BOUND
      DO 300 J=2,M2
  300 T(L1,J)=T(L2,J)
      DO 301 I=2,L2
  301 T(I,1)=T(I,2)
      RETURN
*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,401)
  401 FORMAT(1X,'   ITER',11X,'T(4,5)',14X,'T(5,3)')
  400 WRITE(8,402) ITER,T(4,5),T(5,3)
  402 FORMAT(1X,I6,2F20.5)
      IF(ITER.EQ.LAST) CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 500 I=1,L1
      GAM(I,J)=1.
      GAM(I,1)=0.
      GAM(L1,J)=0.
  500 CONTINUE
      RETURN
      END
