*****************************************************************
      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*----------------- EXAMPLE SEVEN -----------------------------
*
*****************************************************************
      DIMENSION T(22,22)
      EQUIVALENCE (F(1,1,4),T(1,1))
*
      ENTRY GRID
      DO 20 I=1,4
      LSOLVE(I)=.TRUE.
   20 LPRINT(I)=.TRUE.
      LPRINT(5)=.TRUE.
      LPRINT(11)=.TRUE.
      TITLE(1)='.VEL  U.'
      TITLE(2)='.VEL  V.'
      TITLE(3)='.STR FN.'
      TITLE(4)='. TEMP .'
      TITLE(5)='.W/WBAR.'
      TITLE(11)='PRESSURE'
      RELAX(1)=0.5
      RELAX(2)=0.5
      RELAX(11)=0.8
      LAST=25
      XL=1.
      YL=1.
      L1=7
      M1=7
      CALL UGRID
      RETURN
*
      ENTRY START
      GBR=1.E4
      DPDZ=-3000.
      DO 100 J=1,M1
      DO 100 I=1,L1
      U(I,J)=0.
      V(I,J)=0.
      T(I,J)=0.
      T(L1,J)=1.
      F(I,J,5)=100.
      IF(I.EQ.1.OR.I.EQ.L1) F(I,J,5)=0.
      IF(J.EQ.1.OR.J.EQ.M1) F(I,J,5)=0.
  100 CONTINUE
      PR=0.7
      AMU=1.
      AMUP=AMU/PR
      RETURN
*
      ENTRY DENSE
      RETURN
*
      ENTRY BOUND
      FRE=0.
      IF(ITER.LT.20) RETURN
      IF(LSOLVE(5)) GOTO 301
      DO 300 NF=1,4
  300 LSOLVE(NF)=.FALSE.
      LSOLVE(5)=.TRUE.
  301 WBAR=0.
      DO 302 J=2,M2
      DO 302 I=2,L2
  302 WBAR=WBAR+F(I,J,5)*XCV(I)*YCV(J)
      FRE=-DPDZ*2.*XL*YL/(WBAR*AMU)
      RETURN
*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,401)
  401 FORMAT(1X,'  ITER',6X,'SMAX',8X,'SSUM',7X,'V(6,4)',
     &  6X,'T(2,6)',6X,'F.RE')
  400 WRITE(8,403) ITER,SMAX,SSUM,V(6,4),T(2,6),FRE
  403 FORMAT(1X,I6,1P5E12.3)
      IF(ITER.NE.LAST) RETURN
      DO 410 J=1,M1
      DO 410 I=1,L1
  410 F(I,J,5)=F(I,J,5)/WBAR
      CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 500 I=1,L1
      GAM(I,J)=AMU
      IF(NF.NE.4) GOTO 500
      GAM(I,J)=AMUP
      GAM(I,1)=0.
      GAM(I,M1)=0.
  500 CONTINUE
      DO 510 J=2,M2
      DO 510 I=2,L2
      IF(NF.NE.2) GOTO 503
      IF(J.EQ.2) GOTO 510
      TM=(T(I,J)+T(I,J-1))*0.5
      CON(I,J)=TM*GBR
      GOTO 510
  503 IF(NF.NE.5) GOTO 510
      CON(I,J)=-DPDZ
  510 CONTINUE
      RETURN
      END
