
*****************************************************************

      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*----------------- EXAMPLE ELEVEN -----------------------------
*
*****************************************************************
      DIMENSION T(22,22)
      EQUIVALENCE (F(1,1,4),T(1,1))
*
      ENTRY GRID
      DO 20 I=1,2
      LSOLVE(I)=.TRUE.
   20 LPRINT(I)=.TRUE.
      LSOLVE(3)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(11)=.TRUE.
      TITLE(1)='.VEL  U.'
      TITLE(2)='.VEL  V.'
      TITLE(4)='. TEMP .'
      TITLE(11)='PRESSURE'
      RELAX(1)=0.5
      RELAX(2)=0.5
      RELAX(11)=1.0
      LAST=40
      XL=1.
      YL=2.
      L1=7
      M1=12
      CALL UGRID
      RETURN
*
      ENTRY START
      DEPTH=.2
      FLOW=4.
      UIN=100.
      TIN=500.
      TAIR=100.
      HTC=2.
      PR=5.
      CP=1.2
      AMU=1.
      AMUP=AMU/PR
      FDZ=FLOW/DEPTH
      DO 100 J=1,M1
      DO 100 I=1,L1
      U(I,J)=0.
      V(I,J)=0.
      T(I,J)=TAIR
  100 CONTINUE
      RETURN
*
      ENTRY DENSE
      RETURN
*
      ENTRY BOUND
      IF(ITER.LT.35) RETURN
      DO 300 NF=1,3
  300 LSOLVE(NF)=.FALSE.
      LSOLVE(4)=.TRUE.
      RETURN
*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,401)
  401 FORMAT(1X,'  ITER',6X,'SMAX',8X,'SSUM',7X,'V(4,7)',
     &  6X,'U(6,4)',6X,'T(5,9)')
  400 WRITE(8,403) ITER,SMAX,SSUM,V(4,7),U(6,4),T(5,9)
  403 FORMAT(1X,I6,1P5E12.3)
      IF(ITER.NE.LAST) RETURN
      CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 500 I=1,L1
      GAM(I,J)=AMU
      IF(NF.EQ.4) GAM(I,J)=AMUP
      IF(NF.NE.4) GOTO 500
      GAM(I,1)=0.
      GAM(I,M1)=0.
      GAM(1,J)=0.
      GAM(L1,J)=0.
  500 CONTINUE
      IF(NF.NE.1) GOTO 510
      SOR=.5*FDZ/(XCVS(4)*YCV(4))
      CON(4,4)=SOR*UIN
      AP(4,4)=-SOR
      SOR=.5*FDZ/(XCVS(5)*YCV(4))
      CON(5,4)=SOR*UIN
      AP(5,4)=-SOR
      RETURN
  510 IF(NF.NE.2) GOTO 520
      SOR=0.5*FDZ/(XCV(4)*YCVS(4))
      AP(4,4)=-SOR
      SOR=0.5*FDZ/(XCV(4)*YCVS(5))
      AP(4,5)=-SOR
      RETURN
  520 IF(NF.NE.3) GOTO 530
      CON(4,4)=FDZ/(XCV(4)*YCV(4))
      CON(5,9)=-FDZ/(XCV(5)*YCV(9))
      RETURN
  530 IF(NF.NE.4) GOTO 540
      SOR=HTC/(CP*DEPTH)
      DO 531 J=2,M2
      DO 531 I=2,L2
      CON(I,J)=SOR*TAIR
  531 AP(I,J)=-SOR
      SOR=FDZ/(XCV(4)*YCV(4))
      CON(4,4)=CON(4,4)+SOR*TIN
      AP(4,4)=AP(4,4)-SOR
  540 CONTINUE
      RETURN
      END

