*****************************************************************

             SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     & X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*-------------- EXAMPLE TWO --------------------------------
*
*****************************************************************
      DIMENSION T(22,22)
      EQUIVALENCE (F(1,1,4),T(1,1))

*
      ENTRY GRID
      LAST=100
      TITLE(4)='TEMP'
      TITLE(13)='COND'
      LPRINT(4)=.TRUE.
      LSOLVE(4)=.TRUE.
      LPRINT(13)=.TRUE.
      MODE=2
      XL=2.
      YL=1.
      R(1)=1.
      L1=7
      M1=7
      CALL UGRID
      RETURN
*
      ENTRY START
      METHOD=1
      DO 100 J=1,M1
      DO 100 I=1,L1
      T(I,J)=200.
      IF(I.EQ.1) T(I,J)=100.*(1.+Y(J))
  100 CONTINUE
      HTC=5.
      Q=50.
      TF=100.
      GAM1=1.
      RETURN
*
      ENTRY DENSE
      RETURN
*
      ENTRY BOUND
      DO 300 I=2,L2
      T(I,M1)=T(I,M2)
  300 T(I,1)=T(I,2)+Q*YDIF(2)/GAM1
      GY=GAM1/XDIF(L1)
      DO 301 J=2,M2
  301 T(L1,J)=(HTC*TF+GY*T(L2,J))/(HTC+GY)
      RETURN
*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,403) METHOD
  403 FORMAT(1X,'  METHOD =',I1)
      WRITE(8,401)
  401 FORMAT(1X,'   ITER',11X,'T(4,5)',14X,'T(5,3)')
  400 WRITE(8,402) ITER,T(4,5),T(5,3)
  402 FORMAT(1X,I6,2F20.6)
      IF(ITER.EQ.LAST) CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 500 I=1,L1
      GAM(I,J)=GAM1
  500 CONTINUE
      DO 501 J=4,7
      DO 501 I=4,5
  501 GAM(I,J)=0.2*(1.+T(I,J)/100.)
      DO 510 J=2,M2
      DO 510 I=2,L2
      CON(I,J)=100.
      AP(I,J)=-.5
  510 CONTINUE
      IF(METHOD.EQ.1) RETURN
      DO 520 I=2,L2
      GAM(I,M1)=0.
      GAM(I,1)=0.
  520 CON(I,2)=CON(I,2)+Q*R(1)/ARX(2)
      RES=1./HTC+1./GY
      ARES=1./(RES*XCV(L2))
      DO 521 J=2,M2
      GAM(L1,J)=0.
      CON(L2,J)=CON(L2,J)+ARES*TF
  521 AP(L2,J)=AP(L2,J)-ARES
      RETURN
      END



