*****************************************************************

      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*----------------- EXAMPLE THREE  ----------------------------
*

*****************************************************************
      DIMENSION W(22,22),T(22,22)
      EQUIVALENCE(F(1,1,4),W(1,1)),(F(1,1,5),T(1,1))
*
      ENTRY GRID
      LSOLVE(4)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(5)=.TRUE.
      TITLE(4)='.W/WBAR.'
      TITLE(5)='.THETA.'
      LAST=22
      XL=0.5
      YL=0.5
      L1=7
      M1=7
      CALL UGRID
      RETURN
*
      ENTRY START
      TW=0.
      DO 100 J=1,M1
      DO 100 I=1,L1
      W(I,J)=0.
      T(I,J)=1.
      T(I,M1)=TW
      T(L1,J)=TW
  100 CONTINUE
      AMU=1.
      DEN=1.
      COND=1.
      CP=1.
      RHOCP=DEN*CP
      DPDZ=-100.
      DTBDZ=5.
      RETURN
*
      ENTRY DENSE
      RETURN
*
      ENTRY BOUND
      ASUM=0.
      WSUM=0.
      TSUM=0.
      DO 300 J=2,M2
      DO 300 I=2,L2
      AR=XCV(I)*YCV(J)
      WR=W(I,J)*AR
      WSUM=WSUM+WR
      ASUM=ASUM+AR
  300 TSUM=TSUM+WR*T(I,J)
      WBAR=WSUM/ASUM
      TB=TSUM/(WSUM+1.E-30)
      DH=4.*XL*YL/(XL+YL)
      RE=DEN*WBAR*DH/AMU
      FRE=-2.*DPDZ*DH/(DEN*WBAR**2+1.E-30)*RE
      QW=DTBDZ*RHOCP*WSUM/(XL+YL)
      ANU=QW*DH/(COND*(TW-TB)+1.E-30)
      IF(ITER.NE.10) GOTO 301
      LSOLVE(5)=.TRUE.
      LSOLVE(4)=.FALSE.
  301 CONTINUE
      RETURN

*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,401)
  401 FORMAT(1X,' ITER',12X,'F.RE',17X,'NU')
  400 WRITE(8,402) ITER,FRE,ANU
  402 FORMAT(1X,I6,1P2E20.4)
      IF(ITER.NE.LAST) RETURN
      DO 410 J=1,M1
      DO 410 I=1,L1
      W(I,J)=W(I,J)/WBAR
  410 T(I,J)=(T(I,J)-TW)/(TB-TW)
      CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 I=1,L1
      DO 500 J=1,M1
      GAM(I,J)=AMU
      IF(NF.EQ.5) GAM(I,J)=COND
      GAM(I,1)=0.
      GAM(1,J)=0.
  500 CONTINUE
      IF(NF.EQ.5) GOTO 511
      DO 510 J=2,M2
      DO 510 I=2,L2
      CON(I,J)=-DPDZ
  510 CONTINUE
      RETURN
  511 DO 520 J=2,M2
      DO 520 I=2,L2
      THEAT=(T(I,J)-TW)/(TB-TW+1.E-30)
      DTDZ=THEAT*DTBDZ
  520 CON(I,J)=-RHOCP*W(I,J)*DTDZ
      RETURN
      END
