
*****************************************************************
      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*----------------- EXAMPLE NINE -----------------------------
*
*****************************************************************
      DIMENSION FLOX(22,22),FUEL(22,22),OX(22,22)
      DIMENSION H(22,22),T(22,22),RSW(22,22)
      EQUIVALENCE (F(1,1,4),FLOX(1,1)),(F(1,1,5),FUEL(1,1)),
     &  (F(1,1,6),OX(1,1)),(F(1,1,7),H(1,1)),(F(1,1,8),T(1,1)),
     &  (F(1,1,9),RSW(1,1))
*
      ENTRY GRID
      DO 20 I=1,3
      LSOLVE(I)=.TRUE.
   20 LPRINT(I)=.TRUE.
      LSOLVE(4)=.TRUE.
      LSOLVE(7)=.TRUE.
      LSOLVE(9)=.TRUE.
      LPRINT(5)=.TRUE.
      LPRINT(6)=.TRUE.
      LPRINT(8)=.TRUE.
      LPRINT(9)=.TRUE.
      LPRINT(11)=.TRUE.
      LPRINT(12)=.TRUE.
      TITLE(1)='.VEL  U.'
      TITLE(2)='.VEL  V.'
      TITLE(3)='.STR FN.'
      TITLE(5)='. FUEL .'
      TITLE(6)='.OXYGEN.'
      TITLE(8)='. TEMP .'
      TITLE(9)='.R.VTHE.'
      TITLE(11)='PRESSURE'
      TITLE(12)='. RHO .'
      RELAX(1)=0.5
      RELAX(2)=0.5
      RELAX(11)=0.8
      RELAX(12)=0.5
      LAST=30
      MODE=2
      XL=1.
      YL=.2
      L1=7
      M1=10
      R(1)=0.
      CALL UGRID
      RETURN
*
      ENTRY START
      AI=4.
      CP=1000.
      TIN=300.
      RHOCON=10.
      WFU=16.
      WOX=32.
      WPR=28.
      HFU=3.E7
      ARFU=20.
      DO 100 J=1,M1
      DO 100 I=1,L1
      U(I,J)=20.
      U(2,J)=0.
      U(I,M1)=0.
      V(I,J)=0.
      RSW(I,J)=0.
      P(I,J)=0.
      FLOX(I,J)=-0.232/AI
      H(I,J)=CP*TIN
  100 CONTINUE
      AMU=0.1
      PR=0.7
      AMUP=AMU/PR
      U(2,M2)=20.
      U(2,3)=50.
      RATIO=1./(WFU*(.232/WOX+.768/WPR))
      U(2,2)=(U(2,3)*YCVR(3)+U(2,M2)*YCVR(M2))*RATIO/(YCVR(2)
     &  *ARFU)
      H(1,2)=CP*TIN+HFU
      FLOX(1,2)=1.
      RSW(1,3)=R(3)*U(2,3)*.2
      RETURN
*
      ENTRY DENSE
      DO 200 J=1,M1
      DO 200 I=1,L1
      FUEL(I,J)=AMAX1(0.,FLOX(I,J))
      OX(I,J)=AMAX1(0.,-AI*FLOX(I,J))
      T(I,J)=(H(I,J)-FUEL(I,J)*HFU)/CP
      PROD=1.-FUEL(I,J)-OX(I,J)
      WAV=1./(FUEL(I,J)/WFU+OX(I,J)/WOX+PROD/WPR)
      DEN=RHOCON*WAV/T(I,J)
      IF(ITER.EQ.0) RHO(I,J)=DEN
      RHO(I,J)=DEN*RELAX(NRHO)+RHO(I,J)*(1.-RELAX(NRHO))
  200 CONTINUE
      RETURN
*
      ENTRY BOUND
      IF(ITER.NE.0) GOTO 300
      FLOWIN=0.
      DO 301 J=2,M2
  301 FLOWIN=FLOWIN+RHO(1,J)*U(2,J)*YCVR(J)
  300 FL=0.
      DO 302 J=2,M2
      FL=FL+RHO(L1,J)*U(L2,J)*YCVR(J)
      H(L1,J)=H(L2,J)
  302 FLOX(L1,J)=FLOX(L2,J)
      FACTOR=FLOWIN/FL
      DO 303 J=2,M2
  303 U(L1,J)=U(L2,J)*FACTOR
      RETURN
*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,401)
  401 FORMAT(1X,'  ITER',6X,'SMAX',9X,'SSUM',8X,'U(4,2)',7X,'T(4,2)',7X,
     &    'OX(4,6)')
  400 WRITE(8,403) ITER,SMAX,SSUM,U(4,2),T(4,2),OX(4,6)
  403 FORMAT(1X,I6,1P5E13.4)
      IF(ITER.EQ.LAST) CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 500 I=1,L1
      GAM(I,J)=AMU
      IF(NF.NE.4.AND.NF.NE.7) GOTO 501
      GAM(I,J)=AMUP
      GAM(I,M1)=0.
      GAM(1,J)=0.
  501 GAM(L1,J)=0.
  500 CONTINUE
      IF(NF.NE.2) GOTO 510
      DO 502 J=3,M2
      DO 502 I=2,L2
      RSWM=FY(J)*RSW(I,J)+FYM(J)*RSW(I,J-1)
      RHOM=FY(J)*RHO(I,J)+FYM(J)*RHO(I,J-1)
      CON(I,J)=RHOM*RSWM**2/RMN(J)**3
      AP(I,J)=-AMU/RMN(J)**2
  502 CONTINUE
  510 IF(NF.NE.9) RETURN
      DO 512 J=2,M2
      DO 512 I=2,L2
      AR=2.*AMU/YCVR(J)
      CON(I,J)=AR*RSW(I,J-1)
  512 AP(I,J)=-AR
      RETURN
      END
